/****************************************************************/
/*          													*/
/*      STGA_SW.H  Tabellen zu INIT_VGA  ( Modi & Farben )      */
/*																*/
/*		Die Tabelle anthlt fr jeden Modus alle 				*/
/*		Registerbelegungen, obwohl manche Register in			*/
/*		allen Modi gleich belegt sind, das vereinfacht  		*/
/*		Exerimente.												*/
/*																*/
/*		Basteleien an dieser Datei sollte man wirklich nur		*/
/*		machen, wenn man wei, was man macht!!!!!!!!!!!!!!		*/
/*		Mit dieser Datei kann man einen Bildschirm unter		*/
/*		Umstnden ZERSTREN!!									*/
/*																*/
/****************************************************************/

typedef		char			BYTE;
typedef		unsigned char	UBYTE;
typedef		int				WORD;
typedef		unsigned int	UWORD;
typedef		long			LONG;
typedef		unsigned long	ULONG;

typedef struct rgb
{
 	BYTE  	red;
  	BYTE  	green;
  	BYTE  	blue;
};        	     /* Eintrag in Farbtabelle (CLUT) */

/*--------------------------------------------------------------*/
/*				Bisher implementierte Videomodi					*/
/*--------------------------------------------------------------*/
/*				0		 320 x  200 x   2						*/
/*				1		 640 x  400 x   2 						*/
/*				3		 800 x  608 x   2						*/
/*				4		1024 x  768 x   2						*/
/*				5		1280 x  960 x   2						*/
/*				6		 640 x  400 x  16						*/
/*				7		1280 x  960 x  16						*/
/*              8       1024 x  768 x 256                       */
/*--------------------------------------------------------------*/

char nam[][30]= {		" 320 x  200 -      SW",
						" 640 x  400 -      SW",
						" 800 x  608 -      SW",
						"1024 x  768 -      SW",
						"1280 x  960 -      SW",
						" 640 x  400 -  16 COL",
						"1280 x  960 -  16 COL",
						"1024 x  768 - 256 COL",
						"*"
				};
				
int	x_rez[]=	{		 320, 640, 800,1024,1280, 640,1280,1024	};

int	y_rez[]=	{		 200, 400, 608, 768, 960, 400, 960, 768	};

int	x_byte[]=	{		  40,  80, 100, 128, 160,  80, 160, 128	};

int	col[]=		{		FALS,FALS,FALS,FALS,FALS,TRUE,TRUE,TRUE	};
				
UBYTE misc[]=	{		0x63,0x63,0xef,0x3f,0x2f,0x63,0x2f,0x3f	};

int	ts[][9]=	{	{	 NEL,0x09,0x0f,0x00,0x06, NEL,0x00,0x88,
				 	  	 EOL 									},
					{	 NEL,0x01,0x0f,0x00,0x06, NEL,0x00,0x88,
				 	  	 EOL 									},
				 	{	 NEL,0x01,0x0f,0x00,0x06, NEL,0x00,0x88,
				 		 EOL									},
				 	{	 NEL,0x01,0x0f,0x00,0x06, NEL,0x00,0x88,
				 		 EOL									},
				 	{	 NEL,0x01,0x0f,0x00,0x06, NEL,0x00,0x88,
				 		 EOL									},
				 	{	 NEL,0x01,0x0f,0x00,0x08, NEL,0x00,0x88,
				 		 EOL									},
				 	{	 NEL,0x01,0x0f,0x00,0x08, NEL,0x00,0x88,
				 		 EOL									},
				 	{	 NEL,0x01,0x0f,0x00,0x0e, NEL,0x00,0x88,
				 		 EOL									}
				};
		
int	crtc[][34]=	{	{	0x2d,0x27,0x28,0x90,0x2b,0x80,0xbf,0x1f,
				 		0x00,0x41,0x00,0x00,0x00,0x00,0x00,0x00,
				 		0x9c,0x8e,0x8f,0x14,0x00,0x96,0xb9,0xc3,
				 		0xff, EOL								},
					{	0x5f,0x4f,0x50,0x82,0x54,0x80,0xbf,0x1f,
				 		0x00,0x40,0x00,0x00,0x00,0x00,0x00,0x00,
				 		0x9c,0x8e,0x8f,0x28,0x00,0x96,0xb9,0xc3,
				 		0xff, EOL								},
					{	0x79,0x63,0x64,0x1c,0x68,0x97,0x82,0xf0,
				 		0x00,0x60,0x00,0x00,0x00,0x00,0x00,0x00,
				 		0x64,0x66,0x5f,0x32,0x00,0x64,0x7c,0xc3,
				 		0xff,EOL								},
				 	{	0x9b,0x7f,0x80,0x1e,0x83,0x1c,0x26,0xfd,
				 		0x00,0x60,0x00,0x00,0x00,0x00,0x00,0x00,
				 		0x03,0x8a,0xff,0x40,0x60,0x04,0x22,0xab,
				 		0xff, EOL								},
				  	{	0xbf,0x9f,0xa1,0x9f,0xa2,0xc0,0xff,0xff,
				 		0x00,0x60,0x00,0x00,0x00,0x00,0x00,0x00,
				 		0xcc,0x3f,0xbf,0x50,0x00,0xc4,0xf4,0xc3,
				 		0xff, EOL								},
					{	0x5f,0x4f,0x50,0x82,0x54,0x80,0xbf,0x1f,
				 		0x00,0x40,0x00,0x00,0x00,0x00,0x00,0x00,
				 		0x9c,0x8e,0x8f,0x28,0x00,0x96,0xb9,0xa3,
				 		0xff, EOL								},
				 	{	0xbf,0x9f,0xa1,0x9f,0xa2,0xc0,0xff,0xff,
				 		0x00,0x60,0x00,0x00,0x00,0x00,0x00,0x00,
				 		0xca,0x3f,0xbf,0x50,0x00,0xc4,0xf4,0xc3,
				 		0xff,EOL								},
				 	{	0xa1,0x7f,0x80,0x04,0x89,0x9f,0x26,0xfd,
				 		0x00,0x60,0x00,0x00,0x00,0x00,0x00,0x00,
				 		0x08,0x8a,0xff,0x80,0x60,0x04,0x22,0xab,
				 		0xff, EOL								}
				};
			
int	gdc[][10]=	{	{	0x00,0x00,0x00,0x00,0x00,0x00,0x01,0x0f,
						0xff, EOL								},
					{	0x00,0x00,0x00,0x00,0x00,0x00,0x01,0x0f,
						0xff, EOL								},
					{	0x00,0x00,0x00,0x00,0x00,0x00,0x01,0x0f,
						0xff, EOL								},
					{	0x00,0x00,0x00,0x00,0x00,0x00,0x01,0x0f,
						0xff, EOL								},
					{	0x00,0x00,0x00,0x00,0x00,0x00,0x01,0x0f,
						0xff, EOL								},
					{	0x00,0x00,0x00,0x00,0x00,0x10,0x03,0x0f,
						0xff, EOL								},
					{	0x00,0x00,0x00,0x00,0x00,0x00,0x01,0x0f,
						0xff, EOL								},
					{	0x00,0x00,0x00,0x00,0x00,0x40,0x01,0x0f,
						0xff, EOL								}
				};
			
int	atc[][32]=	{	{	0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,
						0x08,0x09,0x0a,0x0b,0x0c,0x0d,0x0e,0x0f,
						0x01,0x00,0x0f,0x00,0x00, NEL,0x00, EOL },
					{	0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,
						0x08,0x09,0x0a,0x0b,0x0c,0x0d,0x0e,0x0f,
						0x01,0x00,0x0f,0x00,0x00, NEL,0x00, EOL },
					{	0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,
						0x08,0x09,0x0a,0x0b,0x0c,0x0d,0x0e,0x0f,
						0x01,0x00,0x0f,0x00,0x00, NEL,0x00, EOL },
					{	0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,
						0x08,0x09,0x0a,0x0b,0x0c,0x0d,0x0e,0x0f,
						0x01,0x00,0x0f,0x00,0x00, NEL,0x10, EOL },
					{	0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,
						0x08,0x09,0x0a,0x0b,0x0c,0x0d,0x0e,0x0f,
						0x01,0x00,0x0f,0x00,0x00, NEL,0x10, EOL },
					{	0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,
						0x08,0x09,0x0a,0x0b,0x0c,0x0d,0x0e,0x0f,
						0x01,0x00,0x0f,0x00,0x00, NEL,0x00, EOL },
					{	0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,
						0x08,0x09,0x0a,0x0b,0x0c,0x0d,0x0e,0x0f,
						0x01,0x00,0x0f,0x00,0x00, NEL,0x10, EOL },
					{	0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,
						0x08,0x09,0x0a,0x0b,0x0c,0x0d,0x0e,0x0f,
						0x01,0x00,0x0f,0x00,0x00, NEL,0x90, EOL }
				};
/*--------------------------------------------------------------*/

/* === Farbpalette ==================================================== */

struct rgb palette[256] = {
{0x00,0x00,0x00},{0x00,0x00,0x2A},{0x00,0x2A,0x00},{0x00,0x2A,0x2A},
{0x2A,0x00,0x00},{0x2A,0x00,0x2A},{0x2A,0x2A,0x00},{0x2A,0x2A,0x2A},
/* 8 dunkle Farben */
{0x15,0x15,0x15},{0x15,0x15,0x3F},{0x15,0x3F,0x15},{0x15,0x3F,0x3F},
{0x3F,0x15,0x15},{0x3F,0x15,0x3F},{0x3F,0x3F,0x15},{0x3F,0x3F,0x3F},
/* 8 helle Farben */
{0x00,0x00,0x00},{0x05,0x05,0x05},{0x08,0x08,0x08},{0x0B,0x0B,0x0B},
{0x0E,0x0E,0x0E},{0x11,0x11,0x11},{0x14,0x14,0x14},{0x18,0x18,0x18},
{0x1C,0x1C,0x1C},{0x20,0x20,0x20},{0x24,0x24,0x24},{0x28,0x28,0x28},
{0x2D,0x2D,0x2D},{0x32,0x32,0x32},{0x38,0x38,0x38},{0x3F,0x3F,0x3F},
/* 16 Grauwerte */
{0x00,0x00,0x3F},{0x10,0x00,0x3F},{0x1F,0x00,0x3F},{0x2F,0x00,0x3F},
{0x3F,0x00,0x3F},{0x3F,0x00,0x2F},{0x3F,0x00,0x1F},{0x3F,0x00,0x10},
{0x3F,0x00,0x00},{0x3F,0x10,0x00},{0x3F,0x1F,0x00},{0x3F,0x2F,0x00},
{0x3F,0x3F,0x00},{0x2F,0x3F,0x00},{0x1F,0x3F,0x00},{0x10,0x3F,0x00},
{0x00,0x3F,0x00},{0x00,0x3F,0x10},{0x00,0x3F,0x1F},{0x00,0x3F,0x2F},
{0x00,0x3F,0x3F},{0x00,0x2F,0x3F},{0x00,0x1F,0x3F},{0x00,0x10,0x3F},
{0x1F,0x1F,0x3F},{0x27,0x1F,0x3F},{0x2F,0x1F,0x3F},{0x37,0x1F,0x3F},
{0x3F,0x1F,0x3F},{0x3F,0x1F,0x37},{0x3F,0x1F,0x2F},{0x3F,0x1F,0x27},
{0x3F,0x1F,0x1F},{0x3F,0x27,0x1F},{0x3F,0x2F,0x1F},{0x3F,0x37,0x1F},
{0x3F,0x3F,0x1F},{0x37,0x3F,0x1F},{0x2F,0x3F,0x1F},{0x27,0x3F,0x1F},
{0x1F,0x3F,0x1F},{0x1F,0x3F,0x27},{0x1F,0x3F,0x2F},{0x1F,0x3F,0x37},
{0x1F,0x3F,0x3F},{0x1F,0x37,0x3F},{0x1F,0x2F,0x3F},{0x1F,0x27,0x3F},
{0x2D,0x2D,0x3F},{0x31,0x2D,0x3F},{0x36,0x2D,0x3F},{0x3A,0x2D,0x3F},
{0x3F,0x2D,0x3F},{0x3F,0x2D,0x3A},{0x3F,0x2D,0x36},{0x3F,0x2D,0x31},
{0x3F,0x2D,0x2D},{0x3F,0x31,0x2D},{0x3F,0x36,0x2D},{0x3F,0x3A,0x2D},
{0x3F,0x3F,0x2D},{0x3A,0x3F,0x2D},{0x36,0x3F,0x2D},{0x31,0x3F,0x2D},
{0x2D,0x3F,0x2D},{0x2D,0x3F,0x31},{0x2D,0x3F,0x36},{0x2D,0x3F,0x3A},
{0x2D,0x3F,0x3F},{0x2D,0x3A,0x3F},{0x2D,0x36,0x3F},{0x2D,0x31,0x3F},
{0x00,0x00,0x1C},{0x07,0x00,0x1C},{0x0E,0x00,0x1C},{0x15,0x00,0x1C},
{0x1C,0x00,0x1C},{0x1C,0x00,0x15},{0x1C,0x00,0x0E},{0x1C,0x00,0x07},
{0x1C,0x00,0x00},{0x1C,0x07,0x00},{0x1C,0x0E,0x00},{0x1C,0x15,0x00},
{0x1C,0x1C,0x00},{0x15,0x1C,0x00},{0x0E,0x1C,0x00},{0x07,0x1C,0x00},
{0x00,0x1C,0x00},{0x00,0x1C,0x07},{0x00,0x1C,0x0E},{0x00,0x1C,0x15},
{0x00,0x1C,0x1C},{0x00,0x15,0x1C},{0x00,0x0E,0x1C},{0x00,0x07,0x1C},
{0x0E,0x0E,0x1C},{0x11,0x0E,0x1C},{0x15,0x0E,0x1C},{0x18,0x0E,0x1C},
{0x1C,0x0E,0x1C},{0x1C,0x0E,0x18},{0x1C,0x0E,0x15},{0x1C,0x0E,0x11},
{0x1C,0x0E,0x0E},{0x1C,0x11,0x0E},{0x1C,0x15,0x0E},{0x1C,0x18,0x0E},
{0x1C,0x1C,0x0E},{0x18,0x1C,0x0E},{0x15,0x1C,0x0E},{0x11,0x1C,0x0E},
{0x0E,0x1C,0x0E},{0x0E,0x1C,0x11},{0x0E,0x1C,0x15},{0x0E,0x1C,0x18},
{0x0E,0x1C,0x1C},{0x0E,0x18,0x1C},{0x0E,0x15,0x1C},{0x0E,0x11,0x1C},
{0x14,0x14,0x1C},{0x16,0x14,0x1C},{0x18,0x14,0x1C},{0x1A,0x14,0x1C},
{0x1C,0x14,0x1C},{0x1C,0x14,0x1A},{0x1C,0x14,0x18},{0x1C,0x14,0x16},
{0x1C,0x14,0x14},{0x1C,0x16,0x14},{0x1C,0x18,0x14},{0x1C,0x1A,0x14},
{0x1C,0x1C,0x14},{0x1A,0x1C,0x14},{0x18,0x1C,0x14},{0x16,0x1C,0x14},
{0x14,0x1C,0x14},{0x14,0x1C,0x16},{0x14,0x1C,0x18},{0x14,0x1C,0x1A},
{0x14,0x1C,0x1C},{0x14,0x1A,0x1C},{0x14,0x18,0x1C},{0x14,0x16,0x1C},
{0x00,0x00,0x10},{0x04,0x00,0x10},{0x08,0x00,0x10},{0x0C,0x00,0x10},
{0x10,0x00,0x10},{0x10,0x00,0x0C},{0x10,0x00,0x08},{0x10,0x00,0x04},
{0x10,0x00,0x00},{0x10,0x04,0x00},{0x10,0x08,0x00},{0x10,0x0C,0x00},
{0x10,0x10,0x00},{0x0C,0x10,0x00},{0x08,0x10,0x00},{0x04,0x10,0x00},
{0x00,0x10,0x00},{0x00,0x10,0x04},{0x00,0x10,0x08},{0x00,0x10,0x0C},
{0x00,0x10,0x10},{0x00,0x0C,0x10},{0x00,0x08,0x10},{0x00,0x04,0x10},
{0x08,0x08,0x10},{0x0A,0x08,0x10},{0x0C,0x08,0x10},{0x0E,0x08,0x10},
{0x10,0x08,0x10},{0x10,0x08,0x0E},{0x10,0x08,0x0C},{0x10,0x08,0x0A},
{0x10,0x08,0x08},{0x10,0x0A,0x08},{0x10,0x0C,0x08},{0x10,0x0E,0x08},
{0x10,0x10,0x08},{0x0E,0x10,0x08},{0x0C,0x10,0x08},{0x0A,0x10,0x08},
{0x08,0x10,0x08},{0x08,0x10,0x0A},{0x08,0x10,0x0C},{0x08,0x10,0x0E},
{0x08,0x10,0x10},{0x08,0x0E,0x10},{0x08,0x0C,0x10},{0x08,0x0A,0x10},
{0x0B,0x0B,0x10},{0x0C,0x0B,0x10},{0x0D,0x0B,0x10},{0x0F,0x0B,0x10},
{0x10,0x0B,0x10},{0x10,0x0B,0x0F},{0x10,0x0B,0x0D},{0x10,0x0B,0x0C},
{0x10,0x0B,0x0B},{0x10,0x0C,0x0B},{0x10,0x0D,0x0B},{0x10,0x0F,0x0B},
{0x10,0x10,0x0B},{0x0F,0x10,0x0B},{0x0D,0x10,0x0B},{0x0C,0x10,0x0B},
{0x0B,0x10,0x0B},{0x0B,0x10,0x0C},{0x0B,0x10,0x0D},{0x0B,0x10,0x0F},
{0x0B,0x10,0x10},{0x0B,0x0F,0x10},{0x0B,0x0D,0x10},{0x0B,0x0C,0x10},
/* 216 Farben im Farbe-Helligkeit-Sttigung-Modell */
{0x07,0x00,0x07},{0x0F,0x00,0x0F},{0x17,0x00,0x17},{0x1F,0x00,0x1F},
{0x27,0x00,0x27},{0x2F,0x00,0x2F},{0x37,0x00,0x37},{0x3F,0x00,0x3F}
/* 8 mal lila (Rest) */
};

/* === Ende =========================================================== */
